/* calendar.c */
/* print monthly calendar */

#include <stdio.h>

#define CLS       147
#define VERTLINE  124
#define PRINTCHN  5

/* printer constants below */

#define FF        12
#define EXPAND    14
#define NORMAL    15

main ()

  static unsigned month, fullyear;
  static unsigned cal[7][6];
  unsigned year, wkday, lastday;

  input (&month,&fullyear);
  year = (fullyear % 100);
  wkday = weekday (month,1,year);
  lastday = nodays (month,year);
  makecal (wkday,lastday,cal);
  printcal (month,fullyear,cal);


input (month,year)
unsigned *month, *year;


  putchar (CLS);
  printf ("\n Print a Monthly Calendar\n\n");

  *month = *year = 0;

  while ((*month < 1)  (*month > 12))
    
    printf (" Enter the Month Number (1-12): ");
    scanf ("%d",month);
    

  putchar ('\n');

  while ((*year < 1980)  (*year > 2079))
    
    printf (" Enter the Year (1980-2079):    ");
    scanf ("%d",year);
    

  putchar ('\n');



makecal (wkday,numdays,cal)
unsigned wkday, numdays, cal[][6];


  unsigned row, col, startcol;
  unsigned daynum = 1;

  startcol = wkday;

  for (col = 0; col < startcol; col++)
    cal[col][0] = 0;
  
  for (row = 0; row < 6; row++)
    
    for (col = startcol; col < 7; col++)
      
      if (daynum <= numdays)
        cal[col][row] = daynum++;

      else
        cal[col][row] = 0;
      

    startcol = 0;

    


printcal (month,year,cal)
unsigned month,year,cal[][6];


  char *monthname ();
  char *monthptr;
  static char daysofwk[] = "   Sunday     Monday     Tuesday   Wednesday  Thursday    Friday    Saturday";
  char horzline[79];
  unsigned row, col, coldepth;

  open (PRINTCHN,4,7,"");

  for (col = 0; col < 78; col++)
    horzline[col] = '-';
  horzline[78] = '\0';

  monthptr = monthname (month);

  fprintf (PRINTCHN,"\n\n\n\n\n\n");
  fprintf (PRINTCHN,"%c%s %u\n\n",EXPAND,monthptr,year);
  fprintf (PRINTCHN,"%s\n",daysofwk);
  fprintf (PRINTCHN,"%s\n",horzline);

  for (row = 0; row < 6; row++)
    
    if ((row) && (cal[0][row] == 0))
      break;

    fprintf (PRINTCHN,"%c",VERTLINE);

    for (col = 0; col < 7; col++)
      
      if (cal[col][row])
        
        fprintf (PRINTCHN," %c%4u%c",EXPAND,cal[col][row],NORMAL);
        fprintf (PRINTCHN," %c",VERTLINE);
        

      else
        fprintf (PRINTCHN,"          %c",VERTLINE);
      

    fprintf (PRINTCHN,"\n");     

    for (coldepth = 0; coldepth < 5; coldepth++)
      
      fprintf (PRINTCHN,"%c",VERTLINE);
      for (col = 0; col < 7; col++)
        fprintf (PRINTCHN,"          %c",VERTLINE);
      fprintf (PRINTCHN,"\n");     
      
    fprintf (PRINTCHN,"%s\n",horzline);
    

    putc (FF,PRINTCHN);
    close (PRINTCHN);



/* ====================================
 * dayno.c                        
 * calculate reference day number 
 * ------------------------------------
 * in:  month, day, year         
 * out: reference number
 *      (# days past reference date)
 * ====================================
 */

dayno (month, day, year)
int month, day, year;


   int refyear = 80; /* reference day is 01/01/80 */
   int days = 0;
   int curyear;
   unsigned i;

   curyear = year;

   /* count number of days in whole years */

   year --;

   if (year < (refyear - 1))
      year += 100;

   if (refyear <= year)
   
      for (i = refyear; i <= year; i++)
      
         days += 365;
         if ((i % 4) == 0)
            days ++;
      
   

   /* count number of days in whole months */

   month --;
   if (month > 0)
   
      for (i = 1; i <= month; i++)
         days += nodays (i,curyear);
   

   /* add number of days in current month */

   days += day;
   days --;

   return (days);


/* ====================================
 * monthname.c                  
 * return name of month         
 * ------------------------------------
 * in:  month number (1-12)     
 * out: pointer to name of month 
 * ====================================
 */

monthname (monthno)
unsigned monthno;


   static char *monthnms[12] =
      
       "JANUARY", "FEBRUARY", "MARCH",
       "APRIL", "MAY", "JUNE", "JULY",
       "AUGUST", "SEPTEMBER", "OCTOBER",
       "NOVEMBER", "DECEMBER"
      ;

   return (monthnms[monthno - 1]);


/* ====================================
 * nodays.c                           
 * calculate number of days in a month
 * ------------------------------------
 * in:  month, year                 
 * out: number of days in that month 
 * ====================================
 */

nodays (month, year)
unsigned month, year;


   static unsigned nodays[] = 31,28,31,30,31,30,31,31,30,31,30,31;
   unsigned days;
  
   days = nodays[month - 1];

   if ((month == 2) && ((year % 4) == 0))
      days++;

   return (days);


/* ====================================
 * weekday.c                     
 * calculate day of week for date 
 * ------------------------------------
 * in:  month, day, year 
 * out: day of week (0=Sun ... 6=Sat) 
 * ====================================
 */

weekday (month, day, year)
unsigned month, day, year;


   /* refwkday is the weekday of the
    * reference date used by dayno -
    * the reference date is 01/01/80;
    * the weekday is 2 (Tuesday)
    */

   unsigned refwkday = 2;
   unsigned wkday;
 
   wkday = dayno (month, day, year);
   wkday %= 7;
   wkday += refwkday;

   if (wkday > 6)
      wkday -= 7;

   return (wkday);


