/* FULL SCREEN DISK SECTOR EDITOR */

/*
AUTHOR:
   RAYMOND L. ZARLING
   DEPT. COMPUTER SCIENCE
   CAL STATE UNIV, STANISLAUS
   TURLOCK, CA 95380

WRITTEN FOR:
   COMMODORE 64 COMPUTER
COMPILER:
   C-POWER COMPILER V2.4,
      PRO-LINE SOFTWARE, LTD.
DATE:
   AUGUST, 1985
*/

#INCLUDE <STDIO.H>

/* THE FOLLOWING ARE USEFUL FOR CLARITY
AND TO CONSERVE VARIABLE SPACE.
UNFORTUNATELY, C-POWER 2.4 DOES NOT
PERMIT FORMAL PARAMETERS
THAT ARE ONE BYTE LONG, SO
THESE ARE DECLARED "UNSIGNED" WITH
COMMENTS DECLARING THE REAL TYPE. */

#DEFINE  CHAR
#DEFINE  CHAR
#DEFINE  INT

#DEFINE  1
#DEFINE  0

/* C64 MEMORY LOCATIONS */

#DEFINE  (CHAR *)0X00A2
#DEFINE  (CHAR *)0X0286
#DEFINE  (CHAR *)0X02A1
#DEFINE  0XD400

/* COLORS: */

#DEFINE  12
#DEFINE  12
#DEFINE  0
#DEFINE  1

#DEFINE  * = 
#DEFINE  * = 

/* SPECIAL CHARACTERS */

#DEFINE  147
#DEFINE  19
#DEFINE  14
#DEFINE  157
#DEFINE  17

/* FUNCTIONS WHICH RETURN A CHAR LENGTH
RESULT MAY NOT BE EXPLICITY DECLARED
UNDER C-POWER V2.4:

 PRINTV();
CHAR *CVT();
INT EVAL();
 MOD();
 DOPEN();
 DCLOSE();
 DISKERR();
 INSTR1();
 INSTR2();
 DSECT();
 DISPLAY();
 BADTS();
 DEVICE();
 STALL();
 LINEOUT();
CHAR TOASCII();
 TONE();
*/

STATIC  TR, SE;
STATIC CHAR MODE;
STATIC  RS232;
STATIC  OUTF;
STATIC CHAR IMAGE[41];

STATIC CHAR BACK9[]
       =  , , , , , , , , , 0 ;

STATIC CHAR SECTOR[256];
STATIC CHAR LINE[81];

MAIN()

   STATIC  OFFSET, NEWBAUD;
   REGISTER CHAR *LP, *BP, CH;
   REGISTER  UPDATE, MORE;
   STATIC CHAR BAUD[] =  6, 0 ;

   OUTF = STDOUT;
   RS232 = 0;

   *(CHAR *)0XD020 = ;
   *(CHAR *)0XD021 = ;
   PUTCHAR(  );

   *SECTOR = 18; SECTOR[ 1 ] = 1;
   MODE = '';

   FOR (;;)
   
      TR = *SECTOR;
      SE = SECTOR[ 1 ];
      IF ( BADTS () )
      
         TR = 18; SE = 1;
      


      /* SK FOR EXT ECTOR TO ISPLAY: */

      INSTR1();
      PRINTF ( "RACK, ECTOR, MODE? %02D, %02D, %C%S",
         TR, SE, MODE, BACK9 );

      ;
      GETS ( LINE );
      IF ( FEOF ( STDIN ) ) BREAK;
      LP = CVT ( LINE, &TR, 10 );
      LP = CVT ( LP, &SE, 10 );
      WHILE ( *LP ) LP++;
      CH = (*--LP)  0X80;
      IF ( CH == ''  CH == '' )
         MODE = CH;
      IF ( BADTS () )
         BREAK;


      /* ISPLAY THE ECTOR: */

      IF ( DOPEN() ) CONTINUE;
      FPRINTF ( 9, "U1:8 0 %D %D\N", TR, SE );
      IF ( DISKERR( "EADING ISK" ) ) CONTINUE;

      PUTCHAR (  );

      OFFSET = 0;
      BP = SECTOR;
      DO
         *BP++ = GETC ( 8 );
      WHILE ( ++OFFSET );

      DCLOSE ();

      DISPLAY ();


      /* SK FOR ODIFICATIONS: */

      UPDATE = 0;
      MORE = 1;
      DO
      
         PRINTF ( "%C%CX%C", , ,  );
         ;
         *LINE = '\0';
         GETS ( LINE );
         IF ( FEOF ( STDIN ) ) EXIT();

         CH = *LINE;
         SWITCH ( CH )
         
         CASE ':':
            LP = CVT ( LINE, &OFFSET, 16 );
            MOD ( LP, OFFSET );
            BREAK;
         CASE 'P':
         CASE '':
            IF ( DEVICE ( 4, "\021" ) )
               DSECT ();
            DEVICE ( 3 );
            BREAK;
         CASE 'R':
         CASE '':
            CVT ( LINE, &NEWBAUD, 10 );
            IF (NEWBAUD) *BAUD = NEWBAUD;
            DEVICE ( 2, BAUD );
            DSECT ();
            DEVICE ( 3 );
            BREAK;
         CASE '-':
            LP = CVT ( LINE, &TR, 10 );
            CVT ( LP, &SE, 10 );
            IF ( BADTS () ) ABORT();
            BREAK;
         CASE 'A':
         CASE '':
         CASE 'H':
         CASE '':
            MODE = CH  0X80;
            PUTCHAR (  );
            DISPLAY ();
            BREAK;
         CASE 'W':
         CASE '':
            UPDATE = 1;
         CASE 'X':
         CASE '':
            MORE = 0;
            BREAK;
         
       WHILE ( MORE );

      IF ( UPDATE )
      
         IF ( DOPEN() ) CONTINUE;
         FPRINTF ( 9, "B-P:8 0\N" );
         OFFSET = 0;
         BP = SECTOR;
         DO
         
            PUTC ( *BP++, 8 );
           WHILE ( ++OFFSET );
         FPRINTF ( 9, "U2:8 0 %D %D\N", TR, SE );
         IF ( DISKERR( "RITING ISK" ) ) CONTINUE;
         DCLOSE();
      

    /* FOR(;;) */

   ;

 /* END OF MAIN PROGRAM */

 PRINTV ( S, CH )
CHAR *S, CH;
/* CONVERT CH TO A STRING AT S, ACCORDING
TO CURRENT MODE. */

   REGISTER CHAR *FMT;

   IF ( (MODE == '') &&
      ( ISPRINT ( CH )  ISUPPER ( CH ) ) )
      FMT = "'%C";
   ELSE
      FMT = "%02X";
   SPRINTF ( S, FMT, CH );


CHAR *CVT ( P, V, B )
CHAR *P;
 *V, B;
/* CONVERT THE NEXT BASE B NUMBER FOUND
BEGINNING AT P TO A BYTE AT *V.  RETURN
ZERO IF NO BASE B NUMBER FOUND. */

   REGISTER INT D;
   REGISTER  R;

   WHILE ( *P && EVAL( *P, B ) < 0 )
      P++;
   R = 0;
   FOR ( ; *P && (D = EVAL (*P, B)) >= 0; P++ )
      R = R * B + D;
   *V = R;
   RETURN P;


INT EVAL ( CH, B )
UNSIGNED /* CHAR */ CH;
 B;
/* EVALUATE THE CBMASCII CHAR CH IN THE
GIVEN NUMBERING SYSTEM B (<=16).  RETURN
THE RESULT, OR -1 UPON ERROR. */

   REGISTER INT RESULT;
   STATIC CHAR DIGITS[] = "0123456789ABCDEF";

   CH = CH & 0X7F;
   RESULT = B;
   WHILE ( --RESULT >= 0 )
      IF ( DIGITS[ RESULT ] == CH ) BREAK;
   RETURN RESULT;


 LDISP ( OFFSET )
 OFFSET;
/* DISPLAY ONE LINE OF THE SECTOR AT THE
GIVEN OFFSET ON THE CURRENT DEVICE. */

   REGISTER  J;
   REGISTER CHAR *BP, *S;

   ;
   BP = SECTOR + OFFSET;
   SPRINTF ( IMAGE, ":%02X", OFFSET );
   S = IMAGE + 3;
   FOR (J=0; J<16; J++)
   
      IF ( !(J & 3) ) *S++ = ' ';
      PRINTV ( S, *BP++ );
      S += 2;
   
   *S = '\0';
   LINEOUT ( IMAGE );


 MOD ( LINE, O )
CHAR *LINE;
 O;
/* MODIFY A LINE OF DATA AT GIVEN OFFSET
INTO THE SECTOR.  IF ERROR, DO NO MODIFICATION,
AND REDISPLAY ENTIRE SECTOR */

   REGISTER  I, J, RESULT, STATE, OFFSET;
   REGISTER CHAR *LP, CH;
   REGISTER INT E;
   AUTO CHAR DATA[40];

#DEFINE  0
#DEFINE  1
#DEFINE  2
#DEFINE  3

   OFFSET = O;

   I = 0;
   IF ( *LINE ) STATE = ;
   ELSE STATE = ;
   WHILE ( STATE && (CH = *++LINE) )
   
      E = EVAL ( CH, 16 );
      SWITCH ( STATE )
      
      CASE :
         IF ( CH == ' ' ) CONTINUE;
         IF ( CH == '\'' ) STATE = ;
         ELSE IF ( E >= 0 )
         
            RESULT = E;
            STATE = ;
         
         ELSE STATE = ;
         BREAK;
      CASE :
         STATE = ;
         IF ( E >= 0 )
            DATA[I++] = (RESULT<<4) + E;
         ELSE
            STATE = ;
         BREAK;
      CASE :
         DATA [I++] = CH;
         STATE = ;
      
   

   IF ( STATE ==  )
   
      DATA [ I++ ] = ' ';
      STATE = ;
   
   IF ( STATE !=  )
   
      TONE ();
      DISPLAY ();
   
   ELSE
   
      FOR ( J=0; J<I && OFFSET<256; J++)
         SECTOR[ OFFSET++ ] = DATA [ J ];
   


 DOPEN()
/* RETURN  IF ERROR OPENING DISK */

   OPEN( 9, 8, 15, "I0:" );
   IF ( DISKERR ( "NITIALIZING ISK" ) )
      RETURN ;

   OPEN ( 8, 8, 8, "#1" );
   IF ( DISKERR ( "PENING ATA HANNEL" ) )
      RETURN ;

   RETURN ;


 DCLOSE()

/* I KNOW YOU SHOULD USE "CLOSE" WHEN
   THE FILE HAS BEEN OPENED WITH "OPEN",
   BUT "CLOSE" DOES NOT RESET THE EOF
   FLAG, AND "FCLOSE" DOES... */

   FCLOSE ( 8 );
   FCLOSE ( 9 );


 DISKERR( WHEN )
CHAR *WHEN;
/* CHECK FOR DISK ERROR, AND, IF SO,
CLOSE ALL DISK CHANNELS, PRINT ERROR
MSG AND RETURN ERROR NUMBER */

   REGISTER  ERR;

   IF ( ERR = FERROR() )
   
      ;
      DCLOSE ();
      PRINTF ( "%CRROR #%D %S\N", , ERR, WHEN );
      STALL ();
   
   RETURN ERR;


 INSTR1()
/* PRINT THE INSTRUCTIONS WHICH GO ON
THE SCREEN REQUESTING TRACK AND SECTOR
NUMBER */

   ;
   PRINTF ( "%C\N\N              ULL CREEN\N\N",  );
   PRINTF ( "   I S K    E C T O R    D I T O R\N\N" );
   PRINTF ( "          AYMOND . ARLING\N\N\N\N" );
   PRINTF ( "    NTER RACK AND ECTOR NUMBER\N" );
   PRINTF ( "       IN ECIMAL.\N\N" );
   PRINTF ( "    ODE IS  FOR  OR  FOR\N" );
   PRINTF ( "       EXADECIMAL ISPLAY.\N\N" );
   PRINTF ( "    NTER RACK 0 TO UIT.%S\N\N\N" );


 INSTR2()
/* PRINT THE INSTRUCTIONS WHICH GO ON
THE SECTOR DISPLAY SCREEN. */

   PRINTF ( "\NP (OR R)   PRINT SECTOR (R = RS232)\N" );
   PRINTF ( ":ADR DATA  EDIT DATA\N" );
   PRINTF ( "- T S      WRITE THIS DATA TO NEW T, S\N" );
   PRINTF ( "A (OR H)   REDISPLAY IN  (OR HEX)\N" );
   PRINTF ( "X          DON'T WRITE CHANGES TO DISK\N" );
   PRINTF ( "W          WRITE CHANGES TO DISK" );


 DSECT()
/* DISPLAY THE TRACK AND SECTOR NUMBERS,
AND ALL THE DATA IN THE CURRENT SECTOR */

   REGISTER  I;

   ;
   IF ( OUTF != STDOUT ) LINEOUT ( "" );
   SPRINTF ( IMAGE, "--  RACK %D ECTOR %D", TR, SE );
   LINEOUT ( IMAGE );
   LINEOUT ( "" );

   I = 0;
   DO
   
      LDISP ( I );
      I += 16;
     WHILE ( I );


 DISPLAY ()
/* GENERATE THE ENTIRE SECTOR DISPLAY,
WITH INSTRUCTIONS */

   PUTCHAR (  );
   DSECT ();
   INSTR2 ();


 BADTS ()
/* RETURN  IF TR, SE REPRESENT AN
ILLEGAL TRACK AND SECTOR COMBINATION */

STATIC  TSIZE[]
  =  0, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
     20, 20, 20, 20, 20, 20, 20, 18, 18, 18,
     18, 18, 18, 18, 17, 17, 17, 17, 17, 17,
     16, 16, 16, 16, 16;

   RETURN ( TR < 1  TR > 35
          TSIZE[ TR ] < SE );


 DEVICE ( D, S )
UNSIGNED /*  */ D;
CHAR *S;
/* SWITCH THE CURRENT OUTPUT DEVICE TO
DEVICE D ( = 2, 3, OR 4 ).  S IS THE
STRING TO USE IN OPENING THE DEVICE.
USE FILE OUTF AS THE FILE DESCRIPTOR;
OUTF=STDOUT ONLY IF D == 3. */

   WHILE ( * & 3 ); /* WAIT 'TILL 232 DONE */
   CLOSE ( 5 );
   RS232 = ( D == 2 );
   IF ( D == 3 )
      OUTF = STDOUT;
   ELSE IF ( OPEN (5, D, 7, S)  D <= 3 )
      
         OUTF = 5;
         RETURN ;
      
      ELSE
      
         DEVICE ( 3 );
         ;
         PRINTF ( "%CAN'T PEN EVICE %D\N", , D );
         STALL ();
         DISPLAY ();
         RETURN ;
      


 STALL ()
/* WAIT FOR THE USER TO RESPOND */

   PRINTF ( "RESS  TO CONTINUE" );
   WHILE ( GETCHAR () != '\N');


 LINEOUT ( S )
CHAR *S;
/* OUTPUT THE STRING S TO THE CURRENT
DEVICE, FOLLOWED BY \N. */

   REGISTER CHAR C;

   WHILE ( C = *S++ )
   
      IF ( RS232 )
         C = TOASCII ( C );
      PUTC ( C, OUTF );
   
   PUTC ( '\N', OUTF );
   IF ( RS232 )
      PUTC ( '\012', OUTF );


CHAR TOASCII ( CH )
CHAR CH;
/* CONVERT CH TO TRUE ASCII */

   IF ( ISUPPER(CH) )
      RETURN ( CH & 0X7F );
   IF ( ISLOWER(CH) )
      RETURN ( CH  0X20 );
   RETURN CH;


 TONE ()
/* SOUND AN ERROR TONE */

    TIME;

   *(UNSIGNED *) = 0X0400;
   *(UNSIGNED *)( + 5) = 0XF00F;
   *(CHAR *)( + 4) = 0X21;
   *(CHAR *)( + 24) = 0X0F;
   TIME = * + 15;
   WHILE ( TIME != * );
   *(CHAR *)( + 4) = 0;

